package be.ac.ulb.code.wit;

import java.net.MalformedURLException;
import org.apache.cxf.frontend.ClientProxyFactoryBean;
import be.ac.ulb.code.wit.service.Random;

/** 
 * This class implements a simple client that connects & uses the Random Service.
 *
 */

public class ServiceClient {
	public static void main(String args[]) throws MalformedURLException {
		/* The following four lines ask the CXF framework to make a connection to the Random service server
		 * (we point it to the ServiceServer.address; ServiceServer implements the actual server)
		 */		
		ClientProxyFactoryBean factory = new ClientProxyFactoryBean();
		factory.setServiceClass(Random.class);
		factory.setAddress(ServiceServer.address);		
		Random client = (Random) factory.create();
		/* If everything went ok, then the client object now gives us access to the service. */

        try {
            System.out.println("A random facts: " + client.getFact());
        }
        catch (Exception e) {
            e.printStackTrace();
        }

        try {
            System.out.println("3 Random Facts: ");
            for (String s: client.getFacts(3)) {
                System.out.println("- " + s);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
        }

		System.out.println("Number: " + client.getRandom());

        for (int i = 0; i != 10; ++i) {
            System.out.println("Number (between 100 and 105): " + client.getRandom(100, 105));
        }
	}
}
