package be.ac.ulb.code.wit;

import org.apache.cxf.frontend.ServerFactoryBean;

import be.ac.ulb.code.wit.service.Random;
import be.ac.ulb.code.wit.service.RandomImpl;

/** 
 * This class implements a simple service server. The way that this works in CXF is that you:
 * (1) register the interface that contains all the operations that will be supported by the service
 * (2) then register the actual class that implements this interface [and which will hence be used to answer service calls]  
 */
public class ServiceServer {
    public static String address = "http://localhost:8080/facts";
    
	public ServiceServer() {
        ServerFactoryBean factory = new ServerFactoryBean();
        
	    factory.setAddress(address);
	    
	    //Let the framework know the interface that defines the service
	    factory.setServiceClass(Random.class);
	    
	    //TODO: setup the actual service implementation here
	    //factory.setServiceBean(new RandomImpl());
        
        factory.create();
    }

    public static void main(String args[]) throws Exception {
        System.out.println("Starting Server");
        new ServiceServer();
        System.out.println(String.format("Server available at %s",address));
		System.in.read();
    }
}
