package be.ac.ulb.code.wit;

import org.apache.cxf.frontend.ClientProxyFactoryBean;

import be.ac.ulb.code.wit.contacts.Contact;
import be.ac.ulb.code.wit.service.ContactService;
import be.ac.ulb.code.wit.service.GroupService;
import be.ac.ulb.code.wit.service.NoSuchContactException;
import be.ac.ulb.code.wit.service.NoSuchGroupException;

public class ServiceClient {
    private static void printContacts(ContactService service) {
        System.out.println("------------  Contacts  ----------------");
        for (Contact c: service.getContacts()) {
            System.out.println(c);
        }
        System.out.println("----------------------------------------");
    }
    
	public static void main(String args[]) throws NoSuchContactException, NoSuchGroupException {
		ClientProxyFactoryBean factory = new ClientProxyFactoryBean();

        //factory.getInInterceptors().add(new LoggingInInterceptor());
        //factory.getOutInterceptors().add(new LoggingOutInterceptor());

		factory.setServiceClass(ContactService.class);
		factory.setAddress(ServiceServer.contacts_address);
		ContactService client = (ContactService) factory.create();
		
		factory.setServiceClass(GroupService.class);
		factory.setAddress(ServiceServer.groups_address);
		GroupService group = (GroupService) factory.create();

        printContacts(client);
        Contact c = client.createContact("scott.montgomery@starfleet.gxy");

        try {
            client.removeContact("leonard.mccoy@starfleet.gxy");
        }
        catch (NoSuchContactException e) { System.out.println("Already removed!"); }
         
		group.addContactToGroup(c, "Starfleet");
		group.removeContactFromGroup(client.getContact("spock@starfleet.gxy"), "Starfleet");

        printContacts(client);

		System.exit(0);
	}

}
